﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Mortgage_Options_Comparison
{
    public partial class mortgageOptionForm : Form
    {
        public mortgageOptionForm()
        {
            InitializeComponent();
        }

        private void buttonCalculatePayments_Click(object sender, EventArgs e)
        {
            int pV;
            string pVString = textBoxPV.Text;
            int amortization;
            int term;
            double rate;
            double rateDivTwo;
            double jumblyJoo;            
            double jumblyJooMinusOne;
            double loanTimesRate;
            double jumblyJooMini;
            double jumblyJooTeenyWeeny;
            double monthlyPmt;

            if (textBoxPV.Text.IndexOf("$") == 0)
            {
                pVString = pVString.Replace("$", "");
            }
            foreach (char c in pVString)
            {
                if (c.ToString() == ",")
                {
                    pVString = pVString.Replace(",", "");
                }
            }
            
            if (!int.TryParse(pVString, out pV))
            {
                MessageBox.Show("Cannot convert data in Loan Amount textbox to an integer.\n\nPlease amend and try again.");
                return;
            }
            if (!int.TryParse(textBoxAmortization.Text, out amortization))
            {
                MessageBox.Show("Cannot convert data in Amortization textbox to an integer.\n\nPlease amend and try again.");
                return;
            }
            if (!int.TryParse(textBoxTerm.Text, out term))
            {
                MessageBox.Show("Cannot convert data in Term textbox to an Integer.\n\nPlease amend and try again.");
                return;
            }
            
            string rateAlone = textBoxRate.Text;

            foreach (char c in rateAlone)
            {
                if (c.ToString() == "%")
                {
                    rateAlone = rateAlone.Replace("%", "");
                }
            }

            if (!double.TryParse(rateAlone, out rate))
            {
                MessageBox.Show("Cannot convert data in Rate textbox to decimal.\n\nPlease amend and try again.");
                return;
            }

            rateDivTwo = (rate/100) / 2;

            jumblyJoo = Math.Pow((1 + (rateDivTwo)), 0.16666666);

            jumblyJooMinusOne = jumblyJoo - 1;

            loanTimesRate = pV * jumblyJooMinusOne;

            jumblyJooMini = Math.Pow((1 + jumblyJooMinusOne), amortization * 12);

            jumblyJooTeenyWeeny = jumblyJooMini / (jumblyJooMini - 1);

            monthlyPmt = loanTimesRate * jumblyJooTeenyWeeny;

            double monthlyPmtRound = Math.Round(monthlyPmt, 2);

            labelPaymentsDollars.Text = monthlyPmtRound.ToString("C");
        }

        private void labelTotalNumber_Click(object sender, EventArgs e)
        {
            List<string> listOfCCosts = new List<string>();

            listOfCCosts.Add(textBoxLawyer.Text);
            listOfCCosts.Add(textBoxAppraisal.Text);
            listOfCCosts.Add(textBoxLender.Text);
            listOfCCosts.Add(textBoxBroker.Text);

            string[] arrayOfCCostsString = new string[listOfCCosts.Count];
            int[] arrayOfCCostsInt = new int[listOfCCosts.Count];
            int cCostsSum = 0;

            for (int i = 0; i < listOfCCosts.Count; i++)
            {
                arrayOfCCostsString[i] = listOfCCosts[i];
            }

            for (int i = 0; i < listOfCCosts.Count; i++)
            {
                foreach (char c in arrayOfCCostsString[i])
                { 
                    if (c.ToString() == "$")
                    {
                        arrayOfCCostsString[i] = arrayOfCCostsString[i].Replace("$", "");
                    }
                    if (c.ToString() == ",")
                    {
                        arrayOfCCostsString[i] = arrayOfCCostsString[i].Replace(",", "");
                    }
                }

                if (!int.TryParse(arrayOfCCostsString[i], out arrayOfCCostsInt[i]))
                {
                    MessageBox.Show($"One of the above figures can't be converted to an integer.");
                    return;
                }

                cCostsSum += arrayOfCCostsInt[i];
            }

            labelTotalNumber.Text = cCostsSum.ToString("C") + "*";
        }

        private void buttonNetDisb_Click(object sender, EventArgs e)
        {
            List<string> listOfCCosts = new List<string>();

            listOfCCosts.Add(textBoxDisb1.Text);
            listOfCCosts.Add(textBoxDisb2.Text);
            listOfCCosts.Add(textBoxDisb3.Text);
            listOfCCosts.Add(textBoxDisb4.Text);

            string[] arrayOfCCostsString = new string[listOfCCosts.Count];
            int[] arrayOfCCostsInt = new int[listOfCCosts.Count];
            int cCostsSum = 0;

            for (int i = 0; i < listOfCCosts.Count; i++)
            {
                arrayOfCCostsString[i] = listOfCCosts[i];
            }

            for (int i = 0; i < listOfCCosts.Count; i++)
            {
                foreach (char c in arrayOfCCostsString[i])
                {
                    if (c.ToString() == "$")
                    {
                        arrayOfCCostsString[i] = arrayOfCCostsString[i].Replace("$", "");
                    }
                    if (c.ToString() == ",")
                    {
                        arrayOfCCostsString[i] = arrayOfCCostsString[i].Replace(",", "");
                    }
                }

                if (!int.TryParse(arrayOfCCostsString[i], out arrayOfCCostsInt[i]))
                {
                    MessageBox.Show($"One of the above figures can't be converted to an integer.");
                    return;
                }
            }

            cCostsSum = arrayOfCCostsInt[0];
            cCostsSum -= arrayOfCCostsInt[1];
            cCostsSum -= arrayOfCCostsInt[2];
            cCostsSum -= arrayOfCCostsInt[3];

            labelTotalDisb.Text = cCostsSum.ToString("C") + "*";
        }

        private void checkBoxBorrowerView_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxBorrowerView.Checked == true)
            {
                labelBrokerNotes.Visible = false;
                labelLine4.Visible = false;
                textBoxBrokerNotes.Visible = false;
            }
            else
            {
                labelBrokerNotes.Visible = true;
                labelLine4.Visible = true;
                textBoxBrokerNotes.Visible = true;
            }    
        }

        private void mortgageOptionForm_MouseMove(object sender, MouseEventArgs e)
        {
            this.MouseMove -= mortgageOptionForm_MouseMove;
            textBoxDisclaimer.Text = textBoxDisclaimer.Text.Replace("|",Environment.NewLine);
        }
    }
}
